<template>
  <header class="page-header">
    <div class="container">
      <div class="d-flex justify-content-between align-items-center">
        <nuxt-link to="/" class="header-logo" :class="{ white: open }">
          <atom-logo />
        </nuxt-link>
        <button
          v-if="$mq === 'xs' || $mq === 'sm' || $mq === 'md'"
          class="menu-toggler"
          aria-controls="menu"
          aria-label="Navigation öffnen"
          :aria-expanded="`${open}`"
          @click="open = !open"
        >
          <span></span>
          <span></span>
          <span></span>
        </button>
        <div id="menu">
          <nav>
            <ul v-if="menu.length" class="menu-list">
              <li v-for="item in menu" :key="item.id" class="menu-list-item">
                <nuxt-link
                  :to="item.path"
                  class="menu-list-item-link"
                  :class="{ 'link-active': checkIfActive(item) }"
                >
                  {{ item.label }}
                </nuxt-link>
              </li>
            </ul>
          </nav>
          <ul
            v-if="$mq === 'xs' || $mq === 'sm' || $mq === 'md'"
            class="some-links-list"
          >
            <li v-if="options.linkedin" class="some-links-list-item">
              <a
                :href="options.linkedin"
                target="_blank"
                :title="`${options.companyname} bei LinkedIn`"
              >
                <img
                  class="some-icon"
                  src="/img/so-me/linked-in-white.svg"
                  alt="LinkedIn Logo"
                />
              </a>
            </li>
              <li v-if="options.instagram" class="some-links-list-item">
              <a
                :href="options.instagram"
                target="_blank"
                :title="`${options.companyname} bei instagram`"
              >
                <img
                  class="some-icon"
                  src="/img/so-me/instagram.svg"
                  alt="Instagram Logo"
                />
              </a>
            </li>
            <li v-if="options.youtube" class="some-links-list-item">
              <a
                :href="options.youtube"
                target="_blank"
                :title="`${options.companyname} bei YouTube`"
              >
                <img
                  class="some-icon"
                  src="/img/so-me/youtube.svg"
                  alt="YouTube Logo"
                />
              </a>
            </li>
          </ul>
        </div>
      </div>
    </div>
  </header>
</template>

<script>
export default {
  data() {
    return {
      open: false,
    }
  },
  computed: {
    menu() {
      return this.$store.state.menus.main;
    },
    options() {
      return this.$store.state.options;
    },
  },
  watch: {
    $route() {
      this.open = false;
    },
  },
  methods: {
    checkIfActive(item) {
      if (item.path === '/' && this.$route.name === 'index') {
        return true;
      }

      if (this.$route.name && item.label.toLowerCase() === this.$route.name.split('-')[0]) {
        return true;
      }
    },
  },
}
</script>

<style lang="scss" scoped>
$header-base-transition: 0.35s;

.page-header {
  z-index: 9999;
  position: fixed;
  width: 100%;
  top: 0;
  left: 0;
  right: 0;
  padding: 0.875rem 0;
  background-color: $white;
  box-shadow: 0 2px 20px 0 rgba(0, 0, 0, 0.1);

  @include media-breakpoint-up(lg) {
    padding: 1.875rem 0;
  }
}

#menu {
  z-index: 9997;
  display: flex;
  flex-direction: column;
  justify-content: space-evenly;
  position: absolute;
  left: 0;
  right: 0;
  top: 0;
  height: 100vh;
  padding-top: 60px;
  margin: 0;
  background-color: $black;
  color: $white;
  opacity: 0;
  visibility: hidden;
  transition: opacity ease $header-base-transition $header-base-transition,
    visibility ease 0.1s #{$header-base-transition * 2};

  @include media-breakpoint-up(lg) {
    display: block;
    position: relative;
    height: auto;
    padding-top: 0;
    background-color: transparent;
    color: $black;
    transition: none;
    opacity: 1;
    visibility: visible;
  }
}

.menu-list {
  list-style: none;
  padding: 0;
  margin: 0;
  font-family: $font-family-sans-serif;
  font-weight: 600;
  font-size: 1.5rem;
  text-transform: uppercase;
  letter-spacing: 1.2px;
  text-align: center;

  @include media-breakpoint-up(lg) {
    font-size: 1.25rem;
    letter-spacing: 1px;
  }

  .menu-list-item {
    margin: 4rem 0;

    &:first-child {
      margin-top: 0;
    }

    &:last-child {
      margin-bottom: 0;
    }

    @include media-breakpoint-up(lg) {
      display: inline-block;
      margin: 0 1rem;

      &:first-child {
        margin-left: 0;
      }

      &:last-child {
        margin-right: 0;
      }
    }
  }

  .menu-list-item-link {
    color: $white;
    text-decoration: none;

    &:hover,
    &.link-active {
      text-decoration: underline;
      text-decoration-color: $primary;
      text-decoration-thickness: 3px;
      text-underline-position: under;
      text-underline-offset: 0em;

      @include media-breakpoint-up(lg) {
        text-underline-offset: 0.2em;
      }
    }

    @include media-breakpoint-up(lg) {
      color: $black;
    }
  }
}

.some-links-list {
  list-style: none;
  padding: 0;
  margin: 0;
  text-align: center;
  display: none;

  @include media-breakpoint-down(lg) {
    display: block;
  }

  .some-links-list-item {
    display: inline-block;
    margin: 0 0.75rem;
  }

  .some-icon {
    width: 3rem;
    height: 3rem;
  }
}

.header-logo {
  z-index: 9998;
  max-width: 160px;
  max-height: 2rem;

  @include media-breakpoint-up(lg) {
    max-width: 196px;
    max-height: 2.5rem;
  }

  &::v-deep {
    .solon,
    .toggle-shape {
      transition: fill ease $header-base-transition $header-base-transition;
    }
  }

  &.white::v-deep {
    .solon,
    .toggle-shape {
      fill: $white;
    }
  }
}

.menu-toggler {
  z-index: 9998;
  display: none;
  position: relative;
  width: 1.5rem;
  height: 17px;
  padding: 0;
  border: none;
  background-color: transparent;

  @include media-breakpoint-down(lg) {
    display: block;
  }

  span {
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 3px;
    background-color: $black;
    transform-origin: 50% 50%;
    transform: translateY(0);
    transition: top ease $header-base-transition $header-base-transition,
      bottom ease $header-base-transition $header-base-transition,
      transform ease $header-base-transition,
      background-color ease $header-base-transition $header-base-transition;

    &:nth-child(2) {
      top: 7px;
    }

    &:last-child {
      top: auto;
      bottom: 0;
    }
  }

  &[aria-expanded='true'] {
    span {
      background-color: $white;
      transition: top ease $header-base-transition,
        bottom ease $header-base-transition,
        transform ease $header-base-transition $header-base-transition,
        background-color ease $header-base-transition $header-base-transition;

      &:first-child {
        top: 7px;
        transform: rotate(-45deg);
      }

      &:nth-child(2) {
        opacity: 0;
        transform: translateY(-50%);
      }

      &:last-child {
        bottom: 7px;
        transform: rotate(45deg);
      }
    }

    + #menu {
      opacity: 1;
      visibility: visible;
      transition: opacity ease $header-base-transition $header-base-transition,
        visibility ease 0.1s;
    }
  }
}
</style>
